<template>
  <div>
    <div class="card card-custom p-5 gutter-b">
      <div class="card-body p-0">
        <div class="row">
          <div class="col-md-6 py-2 col-sm-12">
            <label for="input-large">Nickname</label>

            <b-form-input
              id="input-large"
              v-model="filter.nickname"
              size="lg"
              placeholder="Masukkan Nickname"
            ></b-form-input>
          </div>

          <div class="col-md-6 py-2 col-sm-12">
            <label for="input-large">Status</label>

            <b-form-select
              v-model="filter.status"
              :options="options.statuses"
              size="lg"
            ></b-form-select>
          </div>
        </div>

        <div class="d-flex justify-content-end">
          <button
            class="btn btn-primary btn-md"
            @click="getDesignManagementPlans(true)"
          >
            <i class="flaticon2-search-1"></i> Filter
          </button>
        </div>
      </div>
    </div>

    <div class="card card-custom p-5 gutter-b">
      <div class="card-body p-0">
        <complete-table :loading="loading" :data="currentDesignManagementPlans">
          <template #header>
            <tr class="text-left">
              <th style="min-width: 250px" class="pl-7">
                <span class="text-dark-75">Kode Proyek</span>
              </th>
              <th style="min-width: 350px">Nama Proyek</th>
              <th style="min-width: 100px">Status</th>
              <th style="min-width: 350px">Owner</th>
              <th style="min-width: 350px">Aksi</th>
            </tr>
          </template>

          <template #body>
            <template v-for="(item, i) in currentDesignManagementPlans">
              <tr v-bind:key="i">
                <td class="pl-0 ">
                  <span
                    class="ml-5 text-dark-75 font-weight-bolder d-block font-size-lg"
                  >
                    {{ item.code }}
                  </span>
                </td>

                <td>
                  <span
                    class="text-dark-75 font-weight-bolder d-block font-size-lg"
                  >
                    {{ item.name }}
                  </span>
                </td>

                <td>
                  <span
                    class="text-dark-75 font-weight-bolder d-block font-size-lg"
                  >
                    {{ item.status }}
                  </span>
                </td>

                <td>
                  <span
                    class="text-dark-75 font-weight-bolder d-block font-size-lg"
                  >
                    {{ item.owner }}
                  </span>
                </td>

                <td>
                  <div class="d-flex">
                    <a
                      class="btn btn-light-info font-weight-bolder font-size-sm mr-2"
                      @click="toEditPage(item)"
                    >
                      <i class="flaticon-edit"></i>
                    </a>

                    <a
                      class="btn btn-light-primary font-weight-bolder font-size-sm mr-2"
                      @click="showRevisionModal(item)"
                    >
                      <i class="flaticon2-refresh"></i>
                    </a>

                    <a
                      class="btn btn-light-success font-weight-bolder font-size-sm mr-2"
                      @click="showUploadModal(item)"
                    >
                      <i class="flaticon-upload"></i>
                    </a>
                  </div>
                </td>
              </tr>
            </template>
          </template>
        </complete-table>
      </div>
    </div>

    <b-modal ref="revisi-dmp" hide-footer title="Revisi DMP">
      <div class="d-block text-center">
        <div class="row">
          <div class="col-md-12 py-2 col-sm-12 text-left">
            <label for="input-large">Nomor DMP Terakhir</label>

            <b-form-input id="input-large" size="lg"></b-form-input>
          </div>

          <div class="col-md-12 py-2 col-sm-12 text-left">
            <label for="input-large">Nomor DMP Revisi</label>

            <b-form-input
              id="input-large"
              size="lg"
              v-model="currentForm.number"
            ></b-form-input>
          </div>

          <div class="col-md-12 py-2 col-sm-12 text-left">
            <label for="input-large">Nomor Revisi Terakhir</label>

            <b-form-input id="input-large" size="lg"></b-form-input>
          </div>

          <div class="col-md-12 py-2 col-sm-12 text-left">
            <label for="input-large">Nomor Revisi</label>

            <b-form-input
              id="input-large"
              size="lg"
              v-model="currentForm.revision"
            ></b-form-input>
          </div>

          <div class="col-md-12 py-2 col-sm-12 text-left">
            <label for="input-large">Tanggal Revisi</label>

            <b-form-input
              id="input-large"
              size="lg"
              type="date"
              v-model="currentForm.revision_date"
            ></b-form-input>
          </div>
        </div>

        <div class="d-flex mt-2">
          <b-button
            class="btn btn-success mr-2"
            block
            :disabled="loading"
            @click="revision"
            >Simpan</b-button
          >

          <b-button
            class="btn btn-secondary mt-0"
            block
            :disabled="loading"
            @click="closeRevisionModal"
            >Batal</b-button
          >
        </div>
      </div>
    </b-modal>

    <b-modal ref="upload-dmp" hide-footer title="Upload DMP">
      <div class="d-block text-center">
        <div class="row">
          <div class="col-md-12 py-2 col-sm-12 text-left">
            <label for="input-large">Nomor DMP Terakhir</label>

            <b-form-input id="input-large" size="lg"></b-form-input>
          </div>

          <div class="col-md-12 py-2 col-sm-12 text-left">
            <label for="input-large">Nomor DMP Revisi</label>

            <b-form-input id="input-large" size="lg"></b-form-input>
          </div>

          <div class="col-md-12 py-2 col-sm-12 text-left">
            <label for="input-large">Nomor Revisi Terakhir</label>

            <b-form-input id="input-large" size="lg"></b-form-input>
          </div>

          <div class="col-md-12 py-2 col-sm-12 text-left">
            <label for="input-large">Nomor Revisi</label>

            <b-form-input id="input-large" size="lg"></b-form-input>
          </div>

          <div class="col-md-12 py-2 col-sm-12 text-left">
            <label for="input-large">Tanggal Revisi</label>

            <b-form-input id="input-large" size="lg" type="date"></b-form-input>
          </div>

          <div class="col-md-12 py-2 col-sm-12 text-left">
            <label for="input-large">Nama EVP</label>

            <b-form-input id="input-large" size="lg"></b-form-input>
          </div>

          <div class="col-md-12 py-2 col-sm-12 text-left">
            <label for="input-large">Nama VP</label>

            <b-form-input id="input-large" size="lg"></b-form-input>
          </div>

          <div class="col-md-12 py-2 col-sm-12 text-left">
            <label for="input-large">File</label>

            <b-form-group>
              <b-form-file id="file-large" size="lg"></b-form-file>
            </b-form-group>
          </div>
        </div>

        <div class="d-flex mt-2">
          <b-button class="btn btn-success mr-2" block @click="closeUploadModal"
            >Simpan</b-button
          >

          <b-button
            class="btn btn-secondary mt-0"
            block
            @click="closeUploadModal"
            >Batal</b-button
          >
        </div>
      </div>
    </b-modal>
  </div>
</template>

<script>
import { SET_BREADCRUMB } from "@/core/services/store/breadcrumbs.module";
import { mapState } from "vuex";
import CompleteTable from "../../content/widgets/advance-table/CompleteTable";
import { arrayMoreThanOne } from "../../../core/helper/array-validation.helper";
import {
  GET_DESIGN_MANAGEMENT_PLAN,
  UPDATE_REVISION_DESIGN_MANAGEMENT_PLAN
} from "../../../core/services/store/design-management-plan.module";

export default {
  name: "DesignManagementPlan",
  components: { CompleteTable },
  data() {
    return {
      filter: {
        status: null,
        nickname: null,
        job_desk: "design"
      },
      currentForm: {
        id: null,
        number: null,
        revision: null,
        revision_date: null
      },
      options: {
        statuses: [
          { value: null, text: "Pilih Status" },
          { value: "open", text: "Open" },
          { value: "close", text: "Close" }
        ]
      },
      selectedProject: null,
      data: {
        projects: [
          {
            id: 1,
            code: "LR98123",
            name: "PEMBANGUNAN SISTEM PERSINYALAN",
            status: "DRAFT",
            owner: "BALAI TEKNIK PERKERETAAPIAN"
          }
        ]
      }
    };
  },

  computed: {
    ...mapState({
      errors: state => state.designManagementPlan.errors,
      loading: state => state.designManagementPlan.loading,
      designManagementPlan: state =>
        state.designManagementPlan.designManagementPlan,
      currentDesignManagementPlan: state =>
        state.designManagementPlan.currentDesignManagementPlan
    }),

    currentDesignManagementPlans() {
      return this.designManagementPlan?.data ?? [];
    }
  },

  methods: {
    getDesignManagementPlans(filter = false) {
      if (!arrayMoreThanOne(this.currentDesignManagementPlans) || filter) {
        this.$store.dispatch(GET_DESIGN_MANAGEMENT_PLAN, {
          params: this.filter
        });
      }
    },

    upload(index, key) {
      this.data.projects[index][key] = "https://google.com";
    },

    deleteFile(index, key) {
      this.data.projects[index][key] = null;
    },

    showRevisionModal(selectedProject) {
      this.selectedProject = selectedProject;

      this.$refs["revisi-dmp"].show();
    },

    closeRevisionModal() {
      this.selectedProject = null;

      this.$refs["revisi-dmp"].hide();

      this.currentForm = {
        id: null,
        number: null,
        revision: null,
        revision_date: null
      };
    },

    showUploadModal(selectedProject) {
      this.selectedProject = selectedProject;

      this.$refs["upload-dmp"].show();
    },

    closeUploadModal() {
      this.selectedProject = null;

      this.$refs["upload-dmp"].hide();
    },

    toEditPage(item) {
      this.$router.push({
        name: "project-design-management-plan-edit",
        params: {
          code: item.code
        }
      });
    },

    revision() {
      this.$store
        .dispatch(UPDATE_REVISION_DESIGN_MANAGEMENT_PLAN, {
          design_management_plan: {
            id: this.selectedProject.code,
            ...this.currentForm
          }
        })
        .then(() => {
          this.closeRevisionModal();
        });
    }
  },

  mounted() {
    this.$store.dispatch(SET_BREADCRUMB, [{ title: "Design Management Plan" }]);

    this.getDesignManagementPlans();
  }
};
</script>

<style></style>
